%define dotests 1
%define  name		cyrus-sasl
%define release		5
%define version 	2.1.26

Summary: 	Simple Authentication and Security Layer (SASL).
License: 	BSD
Name: 		%{name}
Release: 	%{release}
Version:	%{version}
Source0: 	%{name}-%{version}.tar.gz
#sendmail configuration file
Source1:	sendmail.cf
#sendmail binary build with sals support.
Source2:	sendmail 
Patch0:		cyrus-sasl-2.1.26-db.patch
Prefix: 	%{_prefix}
BuildRequires: libgcc >= 8.3.0-1
Requires: libgcc >= 8.3.0-1
Requires:	db >= 5.3.28
Group: 		Development/Tools

#%ifos aix6.1
#Requires: AIX-rpm >= 6.1.0.0
#Requires: AIX-rpm < 6.2.0.0
#%endif
%ifos aix7.1
Requires: AIX-rpm >= 7.1.0.0
Requires: AIX-rpm < 7.2.0.0
%endif
%ifos aix7.2
Requires: AIX-rpm >= 7.2.0.0
Requires: AIX-rpm < 7.3.0.0
%endif

%description
Simple Authentication and Security Layer (SASL) is a framework for authentication
and data security in Internet protocols.
It decouples authentication mechanisms from application protocols, in theory allowing
any authentication mechanism supported by SASL to be used in any application protocol
that uses SASL.

%package devel
Group: Development/Tools
Summary: Development package for the cyrus-sasl
Requires: cyrus-sasl = %{version}-%{release}

%description devel
Development package for the cyrus-sasl.

%prep
%setup -q
%patch0
rm -rf   /tmp/%{name}-%{version}-32bit
cp -pr . /tmp/%{name}-%{version}-32bit
rm -fr *
mv       /tmp/%{name}-%{version}-32bit 32bit
cp -pr 32bit 64bit

%build
#find . -name config.cache | xargs rm

#export PATH=/opt/freeware/bin:/usr/bin:/etc:/usr/sbin:/usr/ucb:/usr/bin/X11:/sbin:/usr/vac/bin:/usr/vacpp/bin:.
#export LDFLAGS="-L/opt/freeware/lib -L/usr/lib -L/lib -bmaxdata:0x80000000 -brtl"
#export LDFLAGS="-L/opt/freeware/lib -L/usr/lib -L/lib -Wl,-bmaxdata:0x80000000"
#export LDFLAGS="-brtl"
#export CC=xlc 
#export CXX=xlC

#Build on 64bit mode
export OBJECT_MODE=64
cd 64bit
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib"
export CC="gcc -maix64 "
export CFLAGS="-I/opt/freeware/include -I/usr/include"

./configure --prefix=%{_prefix} --libdir=%{_libdir}64 --sbindir=%{_sbindir} --enable-login --enable-shared --with-plugindir=%{_libdir}64/sasl2 \
  --disable-gssapi

make

if [ "%{dotests}" == 1 ]
then
    (gmake -k check || true)
fi

#Build on 32bit mode
export OBJECT_MODE=32
cd ../32bit
export CC="gcc -maix32 -D_LARGE_FILES "
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"

./configure --prefix=%{_prefix} --libdir=%{_libdir} --sbindir=%{_sbindir} --enable-login --enable-shared --disable-gssapi

make

if [ "%{dotests}" == 1 ]
then
    (gmake -k check || true)
fi

%install

# install on 64bit mode
export OBJECT_MODE=64
cd 64bit
make install DESTDIR=${RPM_BUILD_ROOT}
mkdir -p  ${RPM_BUILD_ROOT}/etc
mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}
mkdir -p ${RPM_BUILD_ROOT}/var/state/saslauthd

(
cd utils/.libs
cp ./* ${RPM_BUILD_ROOT}%{_sbindir}
)


(
    cd  ${RPM_BUILD_ROOT}%{_prefix}/sbin
    for fic in $(ls -1| grep -v -e _32 -e _64)
    do
	mv $fic "$fic"_64
    done
)
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}64/sasl2
mv ${RPM_BUILD_ROOT}%{_libdir}/sasl2/* ${RPM_BUILD_ROOT}%{_libdir}64/sasl2/

export OBJECT_MODE=32
cd ../32bit

make install DESTDIR=${RPM_BUILD_ROOT}

#cp %{SOURCE1} ${RPM_BUILD_ROOT}/etc/sendmail.cf
#cp %{SOURCE2} ${RPM_BUILD_ROOT}%{_sbindir}     
#chmod +x ${RPM_BUILD_ROOT}%{_sbindir}/sendmail 

(
cd utils/.libs
cp ./* ${RPM_BUILD_ROOT}%{_sbindir}
)


(
    cd  ${RPM_BUILD_ROOT}/%{_prefix}/sbin
    for fic in $(ls -1| grep -v -e _32 -e _64)
    do
	mv $fic "$fic"_32
	ln -sf "$fic"_64 $fic
    done
)


cd ${RPM_BUILD_ROOT}
for dir in lib/sasl2 include/sasl lib/pkgconfig lib64/sasl2 lib64/pkgconfig
do
   mkdir -p usr/$dir
   cd usr/$dir
   ln -sf ../../..%{_prefix}/$dir/* .
   cd -
done

cd ${RPM_BUILD_ROOT}/usr/lib
for f in libsasl2.a libsasl2.la libsasl2.so.3 libsasl2.so.3.0.0
do
   ln -sf ../../..%{_prefix}/lib/$f .
done

cd ${RPM_BUILD_ROOT}/usr/lib64
for f in libsasl2.a libsasl2.la libsasl2.so.3 libsasl2.so.3.0.0
do
   ln -sf ../../..%{_prefix}/lib64/$f .
done

%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

%post
echo "From cyrus-sasl 2.1.26-5 onwards, symbolic links in /usr/sbin has been removed."
echo "The binaries are shipped in /opt/freeware/sbin. Please use absolute path or "
echo "add /opt/freeware/sbin in PATH environment variable to use the binary."

%files
%defattr(-,root,root)
%{_prefix}/sbin/*
%{_prefix}/lib/lib*
%{_prefix}/lib/sasl2/lib*
%{_prefix}/lib/pkgconfig/*
%{_prefix}/lib64/lib*
%{_prefix}/lib64/sasl2/lib*
%{_prefix}/lib64/pkgconfig/*
#%{_prefix}/sbin/sendmail
/usr/lib/lib*
/usr/lib/sasl2/lib*
%dir /var/state/saslauthd
#/usr/lib/pkg*
/usr/lib64/lib*
/usr/lib64/sasl2/lib*
#/etc/sendmail.cf

%{_prefix}/share/man/man3/*
%{_prefix}/share/man/man8/*

%files devel
%defattr(-,root,system)
%{_prefix}/include/*
/usr/include/sasl/*.h

%changelog
* Mon Aug 16 2021 Reshma V Kumar <reskumar@in.ibm.com> - 2.1.26-5
- Rebuild to remove /usr/sbin files

* Wed Aug 1 2018 Reshma V Kumar<reskumar@in.ibm.com> - 2.1.26-3
- Rebuild adding Requires: libgcc >= 6.3.0

* Wed Jul 18 2018 Reshma V Kumar<reskumar@in.ibm.com> - 2.1.26-2
- Update to version 2.1.26 for AIX toolbox

* Fri Dec 16 2016 Juan P Villamizer <jpvillam@us.ibm.com> 2.1.26-1.
- Update to version 2.1.26.
- Include sendmail binary & configuration files. Sendmail included with this rpm is
- compiled to use sasl authentication. So sendmail depends on libsasl.a.


